/*BEGIN OCO COPYRIGHT
 *************************************************************************
 *
 * IBM Confidential
 * OCO Source Materials
 * 5724-L01, 5655-N53, 5724-I82, 5655-R15
 * (C) Copyright IBM Corporation 2006.
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 *
 **************************************************************************
 *END OCO COPYRIGHT
 */

/*
 * Created on Jun 23, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.websphere.samples.databinding;

import java.util.logging.Logger;

import javax.resource.cci.Record;

import com.ibm.j2ca.base.UnstructuredRecord;
import com.ibm.j2ca.extension.emd.runtime.DataTransformationHelper;
import com.ibm.websphere.bo.BOFactory;
import com.ibm.websphere.samples.databinding.log.BindingLogUtil;
import com.ibm.websphere.sca.ServiceManager;
import commonj.connector.runtime.DataBindingException;
import commonj.sdo.DataObject;

/**
 * @author zlainwala
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class EISDataBindingHelper {

	//	BEGIN COPYRIGHT VARIABLE
	public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2006.";	//$NON-NLS-$1
	// END COPYRIGHT VARIABLE
	
	private static final String CLASSNAME = DelimitedEISDataBinding.class.getName();
    private static final Logger LOGGER = BindingLogUtil.initLogger(CLASSNAME);
    
	protected static DataObject getWrapperBO(Record record){
    	BindingLogUtil.logEntry(LOGGER, CLASSNAME, "Entering method getWrapperBO(Record)");  //$NON-NLS-1$ 
    	String recordName = record.getRecordName();    	
        int lastIndex = recordName.lastIndexOf("/");
        
        // get wrapper bgName and namespace from recordName
        String wrapperBGName = recordName.substring(lastIndex+1);
        String wrapperBGNamespace = recordName.substring(0, lastIndex); 	        
        
        //get the wrapper BO Name and namespace
        String wrapperBOName = getBOName(wrapperBGName);
        String wrapperNamespace = getBONamespace(wrapperBGNamespace);
        
        //create a wrapper BO so that the annotations can be retrieved
        //From the annotations, we can get the binding properties
        ServiceManager serviceManager = new ServiceManager();
        BOFactory bofactory = (BOFactory)serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
        DataObject wrapperBO = bofactory.create(wrapperNamespace, wrapperBOName);
        
        BindingLogUtil.logExit(LOGGER, CLASSNAME, "Leaving method getWrapperBO(Record)");  //$NON-NLS-1$ 
        return wrapperBO;
    }
    
    protected static String getBOName(String bgName) {
        if (!bgName.endsWith("BG")) {//$NON-NLS-1$
            return bgName;
        }
        int index = bgName.lastIndexOf("BG");
        return bgName.substring(0, index);//$NON-NLS-1$
    }
    
    protected static String getBONamespace(String bgNamespace) {
        if (!bgNamespace.endsWith("bg"))	//$NON-NLS-1$
        	return bgNamespace;
        int index = bgNamespace.lastIndexOf("bg");	//$NON-NLS-1$
        return bgNamespace.substring(0, index);
    }
    

    protected static DataObject getBindingDataObject(Record record) 
	throws DataBindingException
	{
		BindingLogUtil.logEntry(LOGGER, CLASSNAME, "Entering method getBindingProperties(Record)");  //$NON-NLS-1$
		
		DataObject wrapperBO = getWrapperBO(record);
		// getDataBindingMapping
	    DataObject dataBindingMappingBO = DataTransformationHelper.getAnnotationDataObject(wrapperBO);
	    String contentType = ((UnstructuredRecord)record).getContentType();
	    // getDataBindingConfig
	    DataObject dataBindingConfigBO = DataTransformationHelper.getDataBindingConfigBO(dataBindingMappingBO, contentType);
	    
	    BindingLogUtil.logExit(LOGGER, CLASSNAME, "Leaving method getBindingProperties(Record)");  //$NON-NLS-1$ 
	    return dataBindingConfigBO;
	}
    
    protected static DataObject getBindingDataObject(DataObject dataObject, String contentType)
    	throws DataBindingException
    {
    	BindingLogUtil.logEntry(LOGGER, CLASSNAME, "Entering method getBindingDataObject(DataObject, String)");  //$NON-NLS-1$
		
        DataObject wrapperBO = dataObject.getContainer();	        
        // getDataBindingMapping
        DataObject dataBindingMappingBO = DataTransformationHelper.getAnnotationDataObject(wrapperBO);
        // getDataBindingConfig
        DataObject dataBindingConfigBO = DataTransformationHelper.getDataBindingConfigBO(dataBindingMappingBO, contentType);
        
        BindingLogUtil.logExit(LOGGER, CLASSNAME, "Leaving method getBindingDataObject(DataObject, String)");  //$NON-NLS-1$
		
        return dataBindingConfigBO;
    }
}
