/*BEGIN OCO COPYRIGHT
 *************************************************************************
 *
 * IBM Confidential
 * OCO Source Materials
 * 5724-L01, 5655-N53, 5724-I82, 5655-R15
 * (C) Copyright IBM Corporation 2006.
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 *
 **************************************************************************
 *END OCO COPYRIGHT
 */
 
package com.ibm.websphere.samples.databinding.log;

import java.util.Iterator;
import java.util.List;

import commonj.sdo.DataObject;
import commonj.sdo.Property;
import commonj.sdo.Type;

/**
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 *
 * @author zlainwala
 */
public class DataObjectUtil
{
    static String NEWLINE = System.getProperty("line.separator");  //$NON-NLS-1$
    static StringBuffer dataObjectStr = new StringBuffer();
    
    //	BEGIN COPYRIGHT VARIABLE
	public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2006.";	//$NON-NLS-$1
	// END COPYRIGHT VARIABLE
    /**
     * Automatically generated constructor for utility class
     */
    private DataObjectUtil() {
    }
    
    /**
     * Dump out the data object.
     * @param dataObject
     * @return
     * @author zlainwala
     */
    static public String dump(DataObject dataObject)
    {
        
        Type type = dataObject.getType();
        List properties = type.getProperties();
        Iterator propertyIterator = properties.iterator();
        while(propertyIterator.hasNext())
        {
            Property property = (Property)propertyIterator.next();
            String propertyName = property.getName();
            boolean containment = property.isContainment();
            Object value = null;
            value = dataObject.get(property);
            if(containment && !property.isMany() && value != null)
            {
                    dump((DataObject)value);
                    continue;
            }
            if(containment && property.isMany() && value != null)
            {
                List listValue = (List)value;
                Iterator valueIterator = listValue.iterator();
                while(valueIterator.hasNext())
                {
                    dump((DataObject)valueIterator.next());
                }
            }
            else
            {
                dataObjectStr.append(type.getName() + "." + propertyName + " " + value);  //$NON-NLS-2$  //$NON-NLS-1$ 
                dataObjectStr.append(NEWLINE);
            }
        }
        return dataObjectStr.toString();
    }
}
