/*BEGIN OCO COPYRIGHT
 *************************************************************************
 *
 * IBM Confidential
 * OCO Source Materials
 * 5724-L01, 5655-N53, 5724-I82, 5655-R15
 * (C) Copyright IBM Corporation 2006.
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 *
 **************************************************************************
 *END OCO COPYRIGHT
 */
 
/*
 * Created on Jun 16, 2006
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 *
 */
package com.ibm.websphere.samples.databinding.log;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

import commonj.sdo.DataObject;


/**
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 *
 * @author zlainwala
 */
public class HandlerUtil
{
	//	BEGIN COPYRIGHT VARIABLE
	public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2006.";	//$NON-NLS-$1
	// END COPYRIGHT VARIABLE
 
    /**
     * Automatically generated constructor for utility class
     */
    private HandlerUtil() {
    }

    /**
     * Initialize logger for classname
     *
     * @param className
     * @return
     */
    public static Logger initLogger(String className)
    {
        try {
            Logger log = Logger.getLogger(className);
            log.log(Level.ALL,"Got the logger for "+className);  //$NON-NLS-1$
            return log;

        } catch (Exception ex) {
            com.ibm.ws.ffdc.FFDCFilter.processException(ex, "com.ibm.wbiserver.datahandler.Util.initLogger", "56");  //$NON-NLS-2$  //$NON-NLS-1$
            return null;
        }
    }

    
    /**
     * Log the configuration parameters
     * @param logger
     * @param className
     * @param methodName
     * @param config
     * @author zlainwala
     */
    public static void logConfig(Logger logger, String className, String methodName, HashMap config)
    {
    	if(logger == null) {
    		return;
    	}
        if(config == null)
        {
            logger.logp(Level.FINEST, className, methodName, //$NON-NLS-1$
                        "Incoming configuration is null");  //$NON-NLS-1$
            return;
        }
        StringBuffer configurationMap = new StringBuffer();
        Set configSet = config.entrySet();
        Iterator configIterator = configSet.iterator();
        while(configIterator.hasNext())
        {
            Object value = configIterator.next();
            configurationMap.append(value);
        }
        logger.logp(Level.FINEST, className, "getDataObjectFromString(Reader serializedData, HashMap map)", //$NON-NLS-1$
                    "Created the DataObject: \"{0}\"", configurationMap.toString());  //$NON-NLS-1$

    }

    /**
     * Log the data object values
     * @param logger
     * @param className
     * @param methodName
     * @param dataObject
     * @author zlainwala
     */
    public static void logDataObject(Logger logger, String className, String methodName, DataObject dataObject)
    {
    	if(logger == null) {
    		return;
    	}
        if(dataObject == null)
        {
            logger.logp(Level.FINEST, className, methodName, //$NON-NLS-1$
                        "DataObject is null");  //$NON-NLS-1$
            return;
        }
        
        logger.logp(Level.FINEST, className, "getDataObjectFromString(Reader serializedData, HashMap map)", //$NON-NLS-1$
                    "Created the DataObject: \"{0}\"", DataObjectUtil.dump(dataObject));  //$NON-NLS-1$
    }
}
